import { statisticsFetch } from '../../api/fetch';

function findMaxIndex(list, key) {
  if (!list.length) return -1;
  let max = list[0][key];
  let maxIndex = 0;
  for (let index = 0; index < list.length; index++) {
    const element = list[index];
    if (element >= max) maxIndex = index;
  }
  return maxIndex;
}

// miniprogram/pages/platformFee/platformFee.js
Page({
  /**
   * 页面的初始数据
   */
  data: {
    areaCount: 0,
    year: '',
    dataList: [],
    selected: {
      areaId: undefined,
      areaName: '',
      month: '',
      totalMoney: 0,
    },
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    let year = new Date().getFullYear();
    console.log(year);
    this.fetchList({
      year,
    });
    this.setData!({
      year,
    });
  },
  fetchList(entity) {
    return statisticsFetch({
      url: '/dcxy/platformFee/operate/areas/monthly',
      data: entity,
    })
      .then(res => {
        const { areaCount, platformFees } = res;
        let datalist = new Array(12)
          .fill({
            totalMoney: 0,
          })
          .map((v, idx) => ({ ...v, month: idx + 1 }));
        for (let index = 0; index < platformFees.length; index++) {
          const element = platformFees[index];
          let dataIndex = element.month - 1;
          datalist[dataIndex] = {
            ...datalist[dataIndex],
            ...element,
          };
        }

        this.setData!({
          areaCount,
          dataList: datalist,
        });
        if (datalist && datalist.length) {
          let index = findMaxIndex(datalist, 'totalMoney');
          let item = datalist[index];
          this.setData!({
            selected: item,
          });
        }
      })
      .catch(err => {
        console.log(err);
      });
  },
  yearChangeHandle(e) {
    console.log(e);
    const { value } = e.detail;
    this.fetchList({
      year: value,
    });
  },
  goRecordPage() {
    wx.navigateTo({
      url: '/pages/platformFeeRecord/platformFeeRecord',
    });
  },
  selectedData(e) {
    console.log(e)
    const data = e.detail;
    this.setData!({
      selected: data,
    });
  },
});
